 %% Practice: UWB vs. non-UWB

close all;
clear all;
clc;

%% Checkpoint 1-1
fprintf('Solution of CheckPoint 1-1\n');
%% Signals Generation and Time Domain Analysis
width = (0.1);      % width of the rectangle [s]
points = 1000;     % number of samples used to represent the rectangle
number = 2;        % number of waveform considered

f0 = [0 1e3];          % carrier frequency vector [Hz] 

%invoking genrect_mod

[rect_A, dt_A] = genrect_mod(width,points,f0(1));
[rect_B, dt_B] = genrect_mod(width,points,f0(2));

%graphical output

figure()
time=linspace(-2*width,3*width,5*points);
%time=linspace(1,width,points);
P1=plot(time,rect_A);
set(P1,'LineWidth',2);
axis([-2*width 3*width -1.2 1.2]);
AX=gca;
set(AX,'FontSize',12);
X=xlabel('Time [s]');
set(X,'FontSize',14);
Y=ylabel('Amplitude [V]');
set(Y,'FontSize',14);
% pause

figure()
P1=plot(time,rect_B);
set(P1,'LineWidth',[2]);
set(AX,'FontSize',12);
X=xlabel('Time [s]');
set(X,'FontSize',14);
Y=ylabel('Amplitude [V]');
set(Y,'FontSize',14);
% pause;
%% Frequency Domain Analysis
% dt = width/points
threshold = -3; %3dB
[frac_B_1,f_high_1,f_low_1,BW_1] = bandwidth_mod(rect_A,dt_A,threshold);
% pause; 
[frac_B_2,f_high_2,f_low_2,BW_2] = bandwidth_mod(rect_B,dt_B,threshold);
 pause;
% clc 

%% Checkpoint 1-2
fprintf('Solution of CheckPoint 1-2\n');

Nc = [8 16];
[sinpulse_tf_1,dt_tf_1]=sinpulse_time_fixed(Nc(1));
% pause;
[sinpulse_tf_2,dt_tf_2]=sinpulse_time_fixed(Nc(2));
% pause;
[sinpulse_ff_1,dt_ff_1]=sinpulse_freq_fixed(Nc(1));
% pause;
[sinpulse_ff_2,dt_ff_2]=sinpulse_freq_fixed(Nc(2));
pause;
% clc

fprintf('Solution of Exercise 1\n');
%% Exercise 1: UWB vs. non-UWB
Nc_max = 16;
Bth = 0.5e9;
for i=1:Nc_max
    [sinpulse_ff,dt_ff(i),B(i)]=sinpulse_freq_fixed_impr(i);
    if B(i)<Bth %fp is 3.1 GHz, above 2.5 GHz, look at the Bandwidth! 
        fprintf('\nLast UWB Bandwidth = %f [GHz]\n',B(i-1)*1e-9);
        fprintf('\nNc = %i \n',i-1);
        %[sinpulse_ff_UWB,dt_ff_UWB,B_UWB]=sinpulse_freq_fixed_impr(i-1);
        %[frac_B_UWB,f_high_UWB,f_low_UWB,BW_UWB]=bandwidth_mod(sinpulse_ff_UWB,dt_ff_UWB,-20);
        return
    end
end
% pause;
clc
    



